<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "insurance_company_alias".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "InsuranceCompanyAlias".
 *
 * Columns in table "insurance_company_alias" available as properties of the model,
 * followed by relations of table "insurance_company_alias" available as properties of the model.
 *
 * @property integer $id
 * @property integer $company_id
 * @property string $marketplace_category
 * @property string $issuer_id
 * @property string $alias_name
 * @property string $state_abbreviation
 *
 * @property InsuranceCompany $company
 */
abstract class BaseInsuranceCompanyAlias extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'insurance_company_alias';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'InsuranceCompanyAlias|InsuranceCompanyAliases', $n);
    }

    public static function representingColumn()
    {
        return 'alias_name';
    }

    public function rules()
    {
        return array(
            array('alias_name', 'required'),
            array('company_id, is_popular', 'numerical', 'integerOnly' => true),
            array('marketplace_category', 'length', 'max' => 4),
            array('company_name', 'length', 'max' => 60),
            array('issuer_id', 'length', 'max' => 30),
            array('alias_name', 'length', 'max' => 100),
            array('state_abbreviation', 'length', 'max' => 2),
            array('issuer_id, state_abbreviation', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, is_popular, company_name, company_id, marketplace_category, issuer_id, alias_name, state_abbreviation', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'company' => array(self::BELONGS_TO, 'InsuranceCompany', 'company_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'company_id' => Yii::t('app', 'Insurance Company'),
            'marketplace_category' => Yii::t('app', 'Marketplace Category'),
            'issuer_id' => Yii::t('app', 'Issuer'),
            'alias_name' => Yii::t('app', 'Alias Name'),
            'state_abbreviation' => Yii::t('app', 'State Abbreviation'),
            'is_popular' => Yii::t('app', 'Is Popular'),
            'company' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('company_id', $this->company_id);
        $criteria->compare('marketplace_category', $this->marketplace_category, true);
        $criteria->compare('issuer_id', $this->issuer_id, true);
        $criteria->compare('alias_name', $this->alias_name, true);
        $criteria->compare('company_name', $this->company_name, true);
        $criteria->compare('state_abbreviation', $this->state_abbreviation, true);
        $criteria->compare('is_popular', $this->is_popular, true);

        $sort = new CSort();
        $sort->attributes = array(
            'company_name' => array(
                'asc' => 'company_name',
                'desc' => 'company_name desc',
            ),
            'company_id' => array(
                'asc' => 'company_id',
                'desc' => 'company_id desc',
            ),
            'marketplace_category' => array(
                'asc' => 'marketplace_category',
                'desc' => 'marketplace_category desc',
            ),
            'issuer_id' => array(
                'asc' => 'issuer_id',
                'desc' => 'issuer_id desc',
            ),
            'alias_name' => array(
                'asc' => 'alias_name',
                'desc' => 'alias_name desc',
            ),
            'is_popular' => array(
                'asc' => 'is_popular',
                'desc' => 'is_popular desc',
            ),
        );
        $sort->defaultOrder = 'is_popular, company_name';

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
            'pagination' => array('pageSize' => 10),
            'sort' => $sort
        ));
    }

}
